* WPIX
*
* pjwitte 2oi9+
* All code is my own work except as and where stated
*
* V0.01, pjw, 2019 Oct 17
* V0.02, pjw, 2019 Oct 18, native colour only
* V0.03, pjw, 2022 Nov 01, removed superfluous code
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef WPIX

        xref chan_d6,getpars
        xref xt_wpix

        include dev8_keys_qdos_io
        include dev8_keys_sbasic

*
WPIX
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* WPIX[#ch,] x%, y%, colour
*
* where
*      #ch is an optional channel number (#1 is default)
*      x% / y% are the pixel coordinates within the window channel, and
*      colour is a native colour code
*
* If x%/y% falls outside the window's dimensions, an err.or error is returned.

*
* Possible future version? ::
*
*       WPIX[#ch,] arrx%, arry%, arrcolour
* with all points to be written with one trap call?
*

        moveq #1,d6             default channel number
        bsr chan_d6             a0 = channel ID
        bne.s exit

        moveq #$30,d0           get 3 ints
        bsr getpars
        bne.s exit

        move.l (a6,a1.l),d1     d1 = x | y
        move.w 4(a6,a1.l),d2    d2 is ink colour in native mode

        lea.l xt_wpix,a2
        moveq #-1,d3            timeout
        moveq #iow.xtop,d0
        trap #do.io
        tst.l d0

exit
        rts

*
        end
