* Write pixel
*
* pjwitte 2oi9+
* All code is my own work except as and where stated
*
* V0.01, pjw, 2019 Oct 17
* V0.02, pjw, 2019 Oct 18, Native mode colour supplied
*
* GD2 only!
*


        section code

        xdef xt_wpix

        include dev8_keys_con
        include dev8_keys_sys
        include dev8_keys_err


*
xt_wpix
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Call with
*       d1.l = x | y
*       d2.w = native colour ink
*       a0   = channel ID
* return
*       cc set; various errors
*       d1/a1 smashed, remainder presrved
*

        move.w d1,d0            d0.w = y
        bmi.s err_or

        swap d1                 d1.w = x
        tst.w d1
        bmi.s err_or

        move.l sys_clnk(a6),a4  a4 -> to CON linkage

        cmpi.b #ptm.aur8,pt_dmode(a4) mode < 16?
        bcs.s err_ni

        cmp.w sd_xsize(a0),d1   outside window?
        bge.s err_or

        cmp.w sd_ysize(a0),d0   outside window?
        bge.s err_or

        add.w sd_xmin(a0),d1
        add.w sd_ymin(a0),d0

        mulu.w sd_linel(a0),d0  d0 = llen * y
        add.l sd_scrb(a0),d0    add screen base

        ext.l d1                x
        add.l d1,d0             d0 = screen base + llen * y + x (8 bit)
        move.l d0,a1            a1 = pixel address in window (buffer)

        cmpi.b #ptm.aur8,pt_dmode(a4)
        bhi.s mode3x            mode > 16?

mode16
        move.b d2,(a1)          set 8bit pixel
        bra.s ok

err_or
        moveq #err.orng,d0
        rts

err_ni
        moveq #err.nimp,d0
        rts

mode3x
        add.l d1,a1             address of 16bit pixel
        move.w d2,(a1)          write 16bit pixel

ok
        moveq #0,d0
        rts

*
        end
